/*  
    VTun - Virtual Tunnel over TCP/IP network.

    Copyright (C) 1998,1999  Maxim Krasnyansky <max_mk@yahoo.com>

    VTun has been derived from VPPP package by Maxim Krasnyansky. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 */

/*
 * Version: 1.1 04/12/1999 Maxim Krasnyansky <max_mk@yahoo.com>
 */ 
#ifndef _LINKFD_H
#define _LINKFD_H

/* Size of the buffer (to fit full PPP or Ether frame)*/
#define LINKFD_BUF_SIZE 1560

/* Priority of the proccess in the link_fd function */
#define LINKFD_PRIO -15

#ifdef __alpha__ 
#  define LINKFD_MAGIC 92
#  define LINKFD_FREQ 10000
#endif

#if defined(__i386__) || defined(__i486__) || defined(__i586__) 
#  define LINKFD_MAGIC 85
#  define LINKFD_FREQ 1000
#endif

int linkfd(struct vtun_host *host);

/* Module */
struct lfd_mod {
   char *name;
   int (*alloc)(struct vtun_host *host);
   int (*encode)(int len, char *in, char **out);
   int (*avail_encode)(void);
   int (*decode)(int len, char *in, char **out);
   int (*avail_decode)(void);
   int (*free)(void);

   struct lfd_mod *next;
   struct lfd_mod *prev;
};

/* External LINKFD modules */

extern struct lfd_mod lfd_zcomp;
extern struct lfd_mod lfd_encrypt;

#endif
